const logger = require('../../lib/logger')
const globby = require('globby-extra')
const Promise = require('bluebird')
const NOS = require('../../src/nos')
const path = require('path')

exports.command = 'upload'
exports.desc = 'upload files to nos'
exports.builder = function (yargs) {
  // 检查 config
  return yargs.check(require('../../lib/checkConfig'))
}
exports.handler = function (argv) {
  const {
    host,
    port,
    bucket,
    accessId,
    secretKey,
    prefix,
    pattern,
    context,
    concurrency
  } = argv
  // globby 后上传每一项
  globby(pattern, context).then(paths => {
    const nos = new NOS({
      host,
      port,
      bucket,
      accessId,
      secretKey
    })
    Promise.map(paths, (filePath, index) => {
      return nos.putFilePathAsync({
        // key: prefix + path (without context)
        key: path.join(prefix, filePath.replace(paths.context, '')),
        filePath
      })
    }, {
      concurrency
    }).then(() => {
      logger.success('upload done')
    }, logger.error)
  })
}
