/**
 * Created by hzlichaolin on 2016/7/14.
 * this module get object's meta datas
 */

var httpRequest = require('./httpRequest')
var inherits = require('./inherits')
var authrization = require('../services/authorization')
var encoder = require('../services/urlEncoder')

function headObjectRequest() {
    httpRequest.call(this)

    this.options = {host: null, port: -1, path: null, method: 'HEAD', headers:{}
    };

    this.bucketName = null
    this.objectName = null

    this.ifModifiedSince = null
}

inherits(headObjectRequest,httpRequest)

headObjectRequest.prototype.setBucketName = function (bucketName) {
    this.bucketName = bucketName
}

headObjectRequest.prototype.setObjectName = function (objectName) {
    this.ObjectName = encoder(objectName)
}

headObjectRequest.prototype.setIfModifiedSince = function (ifModifiedSince) {
    this.ifModifiedSince = ifModifiedSince
}

headObjectRequest.prototype.sendRequest = function (func) {
    this.options.path = '/' + this.bucketName + '/' + this.ObjectName
    this.options.headers['Date'] = (new Date()).toUTCString();
    if (this.ifModifiedSince != null){
        this.options.headers['If-Modified-Since'] = this.ifModifiedSince
    }
    var authStr = authrization(this.accessId,this.secretKey,this.options.method,this.options.headers,this.options.path)
    this.options.headers['Authorization'] = authStr
    httpRequest.prototype.sendRequest(this.options,func);
}

module.exports = headObjectRequest