/**
 * Created by hzlichaolin on 2016/7/14.
 * this module list more than one objects from a bucket
 */

var httpRequest = require('./httpRequest')
var inherits = require('./inherits')
var authrization = require('../services/authorization')
var querystring = require('querystring')
var encoder = require('../services/urlEncoder')

function listObjectsRequest() {
    httpRequest.call(this)

    this.options = {host: null, port: -1, path: null, method: 'GET', headers:{}
    };

    this.bucketName = null
    this.delimiter = null
    this.marker = null
    this.max_keys = null
    this.prefix = null
}

inherits(listObjectsRequest,httpRequest)

listObjectsRequest.prototype.setBucketName = function (bucketName) {
    this.bucketName = bucketName
}

listObjectsRequest.prototype.setDelimiter = function (delimiter) {
    this.delimiter = delimiter
}

listObjectsRequest.prototype.setMarker = function (marker) {
    this.marker = marker
}

listObjectsRequest.prototype.setMaxKeys = function (max_keys) {
    this.max_keys = max_keys
}

listObjectsRequest.prototype.setPrefix = function (prefix) {
    this.prefix = prefix
}

listObjectsRequest.prototype.sendRequest = function (func) {

    var para = {}
    if (this.delimiter != null){
        para['delimiter'] = this.delimiter
    }
    if (this.marker != null){
        para['marker'] = this.marker
    }
    if (this.max_keys != null){
        para['max-keys'] = this.max_keys
    }
    if (this.prefix != null){
        para['prefix'] = this.prefix
    }
    var query = querystring.stringify(para)

    if (query.length > 0){
        query = '?'+query
    }

    var resource = '/' + this.bucketName + '/'
    
    this.options.path = '/' + this.bucketName + '/' + query
    this.options.headers['Date'] = (new Date()).toUTCString();
    var authStr = authrization(this.accessId,this.secretKey,this.options.method,this.options.headers,resource)
    this.options.headers['Authorization'] = authStr
    httpRequest.prototype.sendRequest(this.options,func);
}

module.exports = listObjectsRequest