/**
 * Created by hzlichaolin on 2016/7/15.
 * this module copy a object from one bucket to another bucket
 */
var httpRequest = require('./httpRequest')
var inherits = require('./inherits')
var authrization = require('../services/authorization')
var encoder = require('../services/urlEncoder')

function putObjectCopyRequest() {
    httpRequest.call(this)

    this.options = {host: null, port: -1, path: null, method: 'PUT', headers:{}
    };

    this.destBucketName = null
    this.destObjectName = null
    this.sourceBucektName = null
    this.sourceObjectName = null

}

inherits(putObjectCopyRequest,httpRequest)

putObjectCopyRequest.prototype.setDestBucketName = function (destBucketName) {
    this.destBucketName = destBucketName
}

putObjectCopyRequest.prototype.setDestObjectName = function (destObjectName) {
    this.destObjectName = encoder(destObjectName)
}

putObjectCopyRequest.prototype.setSourceBucketName = function (sourceBucketName) {
    this.sourceBucektName = sourceBucketName
}

putObjectCopyRequest.prototype.setSourceObjectName = function (sourceObjectName) {
    this.sourceObjectName = encoder(sourceObjectName)
}

putObjectCopyRequest.prototype.sendRequest = function (func) {
    this.options.path = '/' + this.destBucketName + '/' + this.destObjectName
    this.options.headers['Date'] = (new Date()).toUTCString();
    this.options.headers['x-nos-copy-source'] = '/' + this.sourceBucektName + '/' + this.sourceObjectName
    var authStr = authrization(this.accessId,this.secretKey,this.options.method,this.options.headers,this.options.path)
    this.options.headers['Authorization'] = authStr
    httpRequest.prototype.sendRequest(this.options,func);
}

module.exports = putObjectCopyRequest
